Intro
=====

This document is designed to provide a list of the minimum levels of
software necessary to run the 2.4 kernels, as well as provide brief
instructions regarding any other "Gotchas" users may encounter when
trying life on the Bleeding Edge.  If upgrading from a pre-2.2.x
kernel, please consult the Changes file included with 2.2.x kernels for
additional information; most of that information will not be repeated
here.  Basically, this document assumes that your system is already
functional and running at least 2.2.x kernels.

This document is originally based on my "Changes" file for 2.0.x kernels
and therefore owes credit to the same people as that file (Jared Mauch,
Axel Boldt, Alessandro Sigala, and countless other users all over the
'net).

The latest revision of this document, in various formats, can always
be found at <http://cyberbuzz.gatech.edu/kaboom/linux/Changes-2.4/>.

Feel free to translate this document.  If you do so, please send me a
URL to your translation for inclusion in future revisions of this
document.

Smotrite file <http://oblom.rnc.ru/linux/kernel/Changes.ru>, yavlyaushisya
russkim perevodom dannogo documenta.

Visite <http://www2.adi.uam.es/~ender/tecnico/> para obtener la traducción
al español de este documento en varios formatos.

Eine deutsche Version dieser Datei finden Sie unter
<http://www.stefan-winter.de/Changes-2.4.0.txt>.

Last updated: February 13, 2002

Chris Ricker (kaboom@gatech.edu or chris.ricker@genetics.utah.edu).

Current Minimal Requirements
============================

Upgrade to at *least* these software revisions before thinking you've
encountered a bug!  If you're unsure what version you're currently
running, the suggested command should tell you.

Again, keep in mind that this list assumes you are already
functionally running a Linux 2.2 kernel.  Also, not all tools are
necessary on all systems; obviously, if you don't have any PCMCIA (PC
Card) hardware, for example, you probably needn't concern yourself
with pcmcia-cs.

o  Gnu C                  2.95.3                  # gcc --version
o  Gnu make               3.77                    # make --version
o  binutils               2.9.1.0.25              # ld -v
o  util-linux             2.10o                   # fdformat --version
o  modutils               2.4.14                   # insmod -V
o  e2fsprogs              1.25                    # tune2fs
o  jfsutils               1.0.12                  # fsck.jfs -V
o  reiserfsprogs          3.6.3                   # reiserfsck -V 2>&1|grep reiserfsprogs
o  xfsprogs               2.6.0                   # xfs_db -V
o  pcmcia-cs              3.1.21                  # cardmgr -V
o  quota-tools            3.09                    # quota -V
o  PPP                    2.4.0                   # pppd --version
o  isdn4k-utils           3.1pre1                 # isdnctrl 2>&1|grep version
			  
Kernel compilation
==================

GCC
---

The gcc version requirements may vary depending on the type of CPU in your
computer. The next paragraph applies to users of x86 CPUs, but not
necessarily to users of other CPUs. Users of other CPUs should obtain
information about their gcc version requirements from another source.

The recommended compiler for the kernel is gcc 2.95.x (x >= 3), and it
should be used when you need absolute stability. You may use gcc 3.0.x
instead if you wish, although it may cause problems. Later versions of gcc 
have not received much testing for Linux kernel compilation, and there are 
almost certainly bugs (mainly, but not exclusively, in the kernel) that
will need to be fixed in order to use these compilers. In any case, using
pgcc instead of egcs or plain gcc is just asking for trouble.

Note that gcc 2.7.2.3 is no longer a supported kernel compiler. The kernel
no longer works around bugs in gcc 2.7.2.3 and, in fact, will refuse to
be compiled with it. egcs-1.1.2 has register allocation problems in very
obscure cases. We have ensured the kernel does not trip these in any known
situation. The 2.5 tree is likely to drop egcs-1.1.2 workarounds.

The Red Hat gcc 2.96 compiler subtree can also be used to build this tree.
You should ensure you use gcc-2.96-74 or later. gcc-2.96-54 will not build
the kernel correctly.

gcc 3.3 and 3.4 are both known to work well. gcc 4.0 and 4.1 also work on
a several architectures (i386, x86_64, ppc, sparc, sparc64, alpha). Other
archs will not work. Versions 4.2 and onwards are not supported anymore.
Supporting them would require massive in-depth changes which will add a
lot of bugs and might break older compilers. If you don't have any gcc
below 4.2, check Documentation/using-newer-gcc.txt for instructions.

In addition, please pay attention to compiler optimization.  Anything
greater than -O2 may not be wise.  Similarly, if you choose to use gcc-2.95.x
or derivatives, be sure not to use -fstrict-aliasing (which, depending on
your version of gcc 2.95.x, may necessitate using -fno-strict-aliasing).

Make
----

You will need Gnu make 3.77 or later to build the kernel.

Binutils
--------

Linux on IA-32 has recently switched from using as86 to using gas for
assembling the 16-bit boot code, removing the need for as86 to compile
your kernel.  This change does, however, mean that you need a recent
release of binutils.

If you can, upgrade to the latest 2.9.5 or 2.1x binutils release.  Older
releases such as 2.8, 2.8.xx, and the FSF's 2.9.1 should be avoided if
at all possible.  The later releases of 2.9.1.0.x (anything where x >= 22)
can and do compile the kernel properly, but there are many benefits in
upgrading to 2.9.5 or 2.1x if you're up to it.

System utilities
================

Architectural changes
---------------------

DevFS is now in the kernel.  See Documentation/filesystems/devfs/* in
the kernel source tree for all the gory details.

The Logical Volume Manager (LVM) is now in the kernel.  If you want to
use this, you'll need to install the necessary LVM toolset.

32-bit UID support is now in place.  Have fun!

Linux documentation for functions is transitioning to inline
documentation via specially-formatted comments near their
definitions in the source.  These comments can be combined with the
SGML templates in the Documentation/DocBook directory to make DocBook
files, which can then be converted by DocBook stylesheets to PostScript,
HTML, PDF files, and several other formats.  In order to convert from
DocBook format to a format of your choice, you'll need to install Jade as
well as the desired DocBook stylesheets.

Util-linux
----------

New versions of util-linux provide *fdisk support for larger disks,
support new options to mount, recognize more supported partition
types, have a fdformat which works with 2.4 kernels, and similar goodies.
You'll probably want to upgrade.

Ksymoops
--------

If the unthinkable happens and your kernel oopses, you'll need a 2.4
version of ksymoops to decode the report; see REPORTING-BUGS in the
root of the Linux source for more information.

Modutils
--------

Upgrade to recent modutils to fix various outstanding bugs which are
seen more frequently under 2.4.x, and to enable auto-loading of USB
modules.  In addition, the layout of modules under
/lib/modules/`uname -r`/ has been made more sane, and EXPORT_SYMBOL_GPL 
also requires that you upgrade to a recent modutils.

Mkinitrd
--------

These changes to the /lib/modules file tree layout also require that
mkinitrd be upgraded.

E2fsprogs
---------

The latest version of e2fsprogs fixes several bugs in fsck and
debugfs.  Obviously, it's a good idea to upgrade.

JFSutils
--------

The jfsutils package contains the utilities for the file system.
The following utilities are available:
o fsck.jfs - initiate replay of the transaction log, and check
  and repair a JFS formatted partition.
o mkfs.jfs - create a JFS formatted partition.
o other file system utilities are also available in this package.

Reiserfsprogs
-------------

The reiserfsprogs package should be used for reiserfs-3.6.x
(Linux kernels 2.4.x). It is a combined package and contains working
versions of mkreiserfs, resize_reiserfs, debugreiserfs and
reiserfsck. These utils work on both i386 and alpha platforms.

Xfsprogs
--------

The latest version of xfsprogs contains mkfs.xfs, xfs_db, and the
xfs_repair utilities, among others, for the XFS filesystem.  It is
architecture independent and any version from 2.0.0 onward should
work correctly with this version of the XFS kernel code (2.6.0 or
later is recommended, due to some significant improvements).


Pcmcia-cs
---------

PCMCIA (PC Card) support is now partially implemented in the main
kernel source.  Pay attention when you recompile your kernel ;-).
Also, be sure to upgrade to the latest pcmcia-cs release.

Quota-tools
-----------

Support for 32 bit uid's and gid's is required if you want to use
the newer version 2 quota format.  Quota-tools version 3.07 and
newer has this support.  Use the recommended version or newer
from the table above.

Intel IA32 microcode
--------------------

A driver has been added to allow updating of Intel IA32 microcode,
accessible as both a devfs regular file and as a normal (misc)
character device.  If you are not using devfs you may need to:

mkdir /dev/cpu
mknod /dev/cpu/microcode c 10 184
chmod 0644 /dev/cpu/microcode

as root before you can use this.  You'll probably also want to
get the user-space microcode_ctl utility to use with this.

If you have compiled the driver as a module you may need to add
the following line:

alias char-major-10-184 microcode

to your /etc/modules.conf file.

Powertweak
----------

If you are running v0.1.17 or earlier, you should upgrade to
version v0.99.0 or higher. Running old versions may cause problems
with programs using shared memory.

Networking
==========

General changes
---------------

The IP firewalling and NAT code has been replaced again.  The new
netfilter software (including ipfwadm and ipchains backwards-
compatible modules) is currently distributed separately.

If you have advanced network configuration needs, you should probably
consider using the network tools from ip-route2.

PPP
---

The PPP driver has been restructured to support multilink and to
enable it to operate over diverse media layers.  If you use PPP,
upgrade pppd to at least 2.4.0.

If you are not using devfs, you must have the device file /dev/ppp
which can be made by:

mknod /dev/ppp c 108 0

as root.

If you build ppp support as modules, you will need the following in
your /etc/modules.conf file:

alias char-major-108	ppp_generic
alias /dev/ppp		ppp_generic
alias tty-ldisc-3	ppp_async
alias tty-ldisc-14	ppp_synctty
alias ppp-compress-21	bsd_comp
alias ppp-compress-24	ppp_deflate
alias ppp-compress-26	ppp_deflate

If you use devfsd and build ppp support as modules, you will need
the following in your /etc/devfsd.conf file:

LOOKUP	PPP	MODLOAD

Isdn4k-utils
------------

Due to changes in the length of the phone number field, isdn4k-utils
needs to be recompiled or (preferably) upgraded.

Getting updated software
========================

Kernel compilation
******************

egcs 1.1.2 (gcc 2.91.66)
------------------------
o  <ftp://sourceware.cygnus.com/pub/gcc/releases/egcs-1.1.2/egcs-1.1.2.tar.bz2>

gcc 2.95.3
----------
o  <ftp://ftp.gnu.org/gnu/gcc/gcc-2.95.3.tar.gz>

Make 3.77
---------
o  <ftp://ftp.gnu.org/gnu/make/make-3.77.tar.gz>

Binutils
--------
o  <ftp://ftp.kernel.org/pub/linux/devel/binutils/>

System utilities
****************

Util-linux
----------
o  <ftp://ftp.kernel.org/pub/linux/utils/util-linux/>

Ksymoops
--------
o  <ftp://ftp.kernel.org/pub/linux/utils/kernel/ksymoops/v2.4/>

Modutils
--------
o  <ftp://ftp.kernel.org/pub/linux/utils/kernel/modutils/v2.4/>

Mkinitrd
--------
o  <ftp://rawhide.redhat.com/pub/rawhide/SRPMS/SRPMS/>

E2fsprogs
---------
o  <http://prdownloads.sourceforge.net/e2fsprogs/e2fsprogs-1.25.tar.gz>

JFSutils
---------
o  <http://jfs.sourceforge.net/>

Reiserfsprogs
-------------
o  <http://www.namesys.com/pub/reiserfsprogs/reiserfsprogs-3.6.3.tar.gz>

Xfsprogs
--------
o  <ftp://oss.sgi.com/projects/xfs/download/>

LVM toolset
-----------
o  <http://www.sistina.com/lvm/>

Pcmcia-cs
---------
o  <ftp://pcmcia-cs.sourceforge.net/pub/pcmcia-cs/pcmcia-cs-3.1.21.tar.gz>

Quota-tools
----------
o  <http://sourceforge.net/projects/linuxquota/>

Jade
----
o  <ftp://ftp.jclark.com/pub/jade/jade-1.2.1.tar.gz>

DocBook Stylesheets
-------------------
o  <http://nwalsh.com/docbook/dsssl/>

Intel P6 microcode
------------------
o  <http://www.urbanmyth.org/microcode/>

Powertweak
----------
o  <http://powertweak.sourceforge.net/>

Networking
**********

PPP
---
o  <ftp://ftp.samba.org/pub/ppp/ppp-2.4.0.tar.gz>

Isdn4k-utils
------------
o  <ftp://ftp.isdn4linux.de/pub/isdn4linux/utils/isdn4k-utils.v3.1pre1.tar.gz>

Netfilter
---------
o  <http://netfilter.filewatcher.org/iptables-1.2.tar.bz2>
o  <http://netfilter.samba.org/iptables-1.2.tar.bz2>
o  <http://netfilter.kernelnotes.org/iptables-1.2.tar.bz2>

Ip-route2
---------
o  <ftp://ftp.inr.ac.ru/ip-routing/iproute2-2.2.4-now-ss991023.tar.gz>

Suggestions and corrections
===========================

Please feel free to submit changes, corrections, gripes, flames,
money, etc. to me <chris.ricker@genetics.utah.edu>.  Happy Linuxing!
